<?php	
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2008 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// version
	$config_version = 'v0.4b';
	
	// db connection
	$config_mysql_host = "localhost";
	$config_mysql_username = '';
	$config_mysql_password = '';
	$config_mysql_dbname = '';
		
	// default settings for new users
	$config_user_lang = 'en';
	$config_user_pass = 'welcome';
	
	// domain suffix for dns input fields
	$config_dns1suffix = '.domain.com';
	$config_dns2suffix = '.domain.com';
	
	// default colors for IP blocks
	$config_color_blocked = 'FFFFFF';
	$config_color_unused = 'D3D3D3';	
		
	// set userlevels
	$config_auth_assetadd = 2;
	$config_auth_assetdel = 2;
	$config_auth_assetedit = 2;
	$config_auth_assetview = 1;
	$config_auth_assetclassadd = 2;
	$config_auth_assetclassdel = 2;
	$config_auth_assetclassedit = 2;
	$config_auth_assetclassview = 1;
	$config_auth_assetclassgroupadd = 2;
	$config_auth_assetclassgroupdel = 2;
	$config_auth_assetclassgroupedit = 2;
	$config_auth_assetclassgroupview = 1;
	$config_auth_assigniptoasset = 2;
	$config_auth_assigniptonode = 2;
	$config_auth_assignlocationtosubnet = 2;
	$config_auth_assignvlantosubnet = 2;
	$config_auth_locationadd = 2;
	$config_auth_locationdel = 2;
	$config_auth_locationedit = 2;
	$config_auth_locationview = 1;
	$config_auth_nodeadd = 2;
	$config_auth_nodedel = 2;
	$config_auth_nodeedit = 2;
	$config_auth_nodeview = 1;
	$config_auth_subnetadd = 2;
	$config_auth_subnetdel = 2;
	$config_auth_subnetedit = 2;
	$config_auth_subnetview = 1;
	$config_auth_useradd = 2;
	$config_auth_userdel = 2;
	$config_auth_useredit = 2;
	$config_auth_userview = 1;
	$config_auth_userclassadd = 2;
	$config_auth_userclassdel = 2;
	$config_auth_userclassedit = 2;
	$config_auth_userclassview = 1;
	$config_auth_userclassauthadd = 2;
	$config_auth_userclassauthdel = 2;
	$config_auth_userclassauthedit = 2;
	$config_auth_userclassauthview = 1;
	$config_auth_vlanadd = 2;
	$config_auth_vlandel = 2;
	$config_auth_vlanedit = 2;
	$config_auth_vlanview = 1;
?>