<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2008 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// include language file
	include('lang/' . $_SESSION['suser_lang'] . '.php');
		
	// set template
	$tp = new Template("tpl/header.tpl");
			
	// set language variables
	$tp->setvars($lang);
	
	// set search box
	if (isset($_POST['search'])) {
		$search = $_POST['search'];
		$_SESSION['search'] = $search;
	} else {
		if(isset($_SESSION['search'])) {
			$search = $_SESSION['search'];
		} else {
			$search = '';
		}
	}
	
	// set global template vars
	$tp->set("config_version", $config_version);
	$tp->set("search", $search);
		
	// output
	$tp->parse();
	$tp->spit();
?>