<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2008 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	session_start();
	
	// check for user_id, if unnkown -> login
	if(empty($_SESSION['suser_id'])) {
		header("Location: login.php");
		exit;
	}
	
	// includes
	include("config.php");
	include("dbconnect.php");
	include("functions.php");
	include("yapter.php");
	
	// auth items
	$authitems = array(
		'ipreg' =>  array(
			'name' => 'IP Reg',
		),
		'asset' => array(
			'name' => 'Asset',
			'item_id' => 'asset_id',
			'item_name' => 'asset_name',
		),
		'assetclass' => array(
			'name' => 'Assetclass',
			'item_id' => 'assetclass_id',
			'item_name' => 'assetclass_name',
		),
		'location' => array(
			'name' => 'Location',
			'item_id' => 'location_id',
			'item_name' => 'location_name',
		),
		'node' => array(
			'name' => 'Node',
			'item_id' => 'node_id',
			'item_name' => 'ip',
		),
		'subnet' => array(
			'name' => 'Subnet',
			'item_id' => 'subnet_id',
			'item_name' => 'subnet_address',
		),
		'user' => array(
			'name' => 'User',
			'item_id' => 'user_id',
			'item_name' => 'user_name',
		),
		'userclass' => array(
			'name' => 'Userclass',
			'item_id' => 'userclass_id',
			'item_name' => 'userclass_name',
		),
		'vlan' => array(
			'name' => 'VLAN',
			'item_id' => 'vlan_id',
			'item_name' => 'vlan_name',
		),
	);
?>