<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2008 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// includes
	include("includes.php");
			
	// get id
	$subnet_id = $_GET['subnet_id'];
	
	// check authorisation
	$auth = auth("node", $config_auth_nodeview, 0);
	$auth = auth("subnet", $config_auth_subnetview, $subnet_id);
	
	// start output
	include("header.php");
	
	// set template
	$tp = new Template("tpl/nodelist.tpl");
	
	// set language variables
	$tp->setvars($lang);
	
	// set variables
	$tp->set("subnet_id", $subnet_id);
	
	// set ordering
	if (isset($_GET['order'])) {
		switch($_GET['order']) {
			case ("asset_name") : $order = "a.asset_name"; break;
			case ("hostname") : $order = "a.hostname"; break;
			case ("mac") : $order = "n.mac"; break;
			case ("dns1") : $order = "n.dns1"; break;
			case ("dns2") : $order = "n.dns2"; break;
			default : $order = "INET_ATON(n.ip)";
		}
	} else {
		$order = "INET_ATON(n.ip)";
	}
	
	// get node info
	$result = mysql_query("SELECT a.asset_id, a.asset_name, a.hostname, n.node_id, n.ip, n.mac, n.dns1, n.dns2 FROM asset a, node n WHERE n.subnet_id='$subnet_id' AND a.asset_id=n.asset_id ORDER BY $order") or die(mysql_error());
	for ($i=0;$row=mysql_fetch_object($result);$i++) {
		$tp->set("asset_id", $row->asset_id);
		$tp->set("asset_name", $row->asset_name);
		$tp->set("hostname", $row->hostname);
		$tp->set("node_id", $row->node_id);
		$tp->set("ip", $row->ip);
		$tp->set("mac", write_mac($row->mac));
		$tp->set("dns1", $row->dns1);
		$tp->set("dns2", $row->dns2);
		$tp->parse("noderow");
	}
	if (($i>0) ? $tp->parse("node") : $tp->hide("node"));
	
	// output
	$tp->parse();
	$tp->spit();
	
	include("footer.php");
?>