<?php
	/*****************************************************************************
	IP Reg, a PHP/MySQL IPAM tool
	Copyright (C) 2008 Wietse Warendorff
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	
	For more information, visit http://sourceforge.net/projects/ipreg,
	or contact me at wietsew@users.sourceforge.net
	*****************************************************************************/
	
	// includes
	include("includes.php");
	
	// get id
	$node_id = $_GET['node_id'];
	
	// check authorisation
	$auth = auth("node", $config_auth_nodeview, $node_id);
	
	// start output
	include("header.php");
	
	// set template
	$tp = new Template("tpl/nodeview.tpl");
	
	// set language variables
	$tp->setvars($lang);
	
	// get node info
	$result = mysql_query("SELECT a.asset_name, a.asset_id, n.ip, n.mac, n.dns1, n.dns2, n.node_info, s.subnet_id, s.subnet_address, s.subnet_mask FROM asset a, node n, subnet s WHERE n.node_id='$node_id' AND a.asset_id=n.asset_id AND s.subnet_id=n.subnet_id") or die(mysql_error());
	$row = mysql_fetch_object($result);
	$tp->set("node_id", $node_id);
	$tp->set("asset_id", $row->asset_id);
	$tp->set("asset_name", $row->asset_name);
	$tp->set("ip", $row->ip);
	$tp->set("mac", write_mac($row->mac));
	$tp->set("dns1", $row->dns1);
	$tp->set("dns2", $row->dns2);
	$tp->set("node_info", nl2br($row->node_info));
	$tp->set("subnet_id", $row->subnet_id);
	$tp->set("subnet_address", $row->subnet_address);
	$tp->set("subnet_mask", $row->subnet_mask);
		
	// output
	$tp->parse();
	$tp->spit();
		
	include("footer.php");
?>